/*--------------/
ALH
main.cpp
INSTGENERATOR: Problem Instance Generator for the SCPP
11/01/2019
/--------------*/

#include "fns.h"

int main(int argc, char** argv) {
    if(argc <= 1) {
        ProgramInfo();
        exit(1);
    }

    for(int j = 1; j < argc; ++j) {
        if(strcmp("-i", argv[j]) == 0) { instance = atoi(argv[++j]); }
        else if(strcmp("-t", argv[j]) == 0) { tau = atoi(argv[++j]); }
        else if(strcmp("-n", argv[j]) == 0) { numItem = atoi(argv[++j]); }
        else if(strcmp("-a", argv[j]) == 0) { minWidth = atoi(argv[++j]); }
        else if(strcmp("-b", argv[j]) == 0) { maxWidth = atoi(argv[++j]); }
        else if(strcmp("-m", argv[j]) == 0) { minItemWidth = atoi(argv[++j]); }
        else if(strcmp("-M", argv[j]) == 0) { maxItemWidth = atoi(argv[++j]); }
        else if(strcmp("-c", argv[j]) == 0) { instType = atoi(argv[++j]); }
        else if(strcmp("-s", argv[j]) == 0) { seed = atoi(argv[++j]); }
    }

    ArgumentCheck();

    int numScores = numItem * 2;
    double totalItemWidth;
    std::vector<int> allScores;
    std::vector<int> partners(numScores, 0);
    std::vector<std::vector<int> > itemWidths(numScores, std::vector<int>(numScores, 0));
    std::vector<std::vector<int> > adjMatrix(numScores, std::vector<int>(numScores, 0));
    std::vector<std::vector<int> > itemNumbers(numScores, std::vector<int>(numScores, 0));
    std::vector<std::vector<int> > itemTypes(4);
    std::vector<int> typeNumber(numScores);


    srand(seed);

    if(instType == 1){
        CreateAInstance(numScores, totalItemWidth, allScores, partners, adjMatrix, itemWidths, itemNumbers);
    }
    else {
        CreateRInstance(numScores, totalItemWidth, allScores, partners, adjMatrix, itemWidths, itemNumbers, itemTypes, typeNumber);
    }

    OutputProbInst(numScores, totalItemWidth, allScores, partners, itemWidths, itemNumbers, itemTypes, typeNumber);




}// END INT MAIN